OpenTTD Source: src/strgen/strgen.h File Reference

OpenTTD Source 15.0-RC2

Data Structures | Macros | Functions | Variables
strgen.h File Reference

Structures related to strgen. More...

`#include "../core/string_consumer.hpp"`
`#include "../language.h"`
`#include "../string_type.h"`
`#include "../3rdparty/fmt/format.h"`
`#include <unordered_map>`
`#include <array>`

Go to the source code of this file.

## Data Structures
struct | Case
| Container for the different cases of a string. More...
struct | LangString
| Information about a single string. More...
struct | StringData
| Information about the currently known strings. More...
struct | StringReader
| Helper for reading strings. More...
struct | HeaderWriter
| Base class for writing the header, i.e. More...
struct | LanguageWriter
| Base class for all language writers. More...
struct | CmdPair
struct | ParsedCommandStruct
struct | StrgenState
| Global state shared between strgen.cpp, game_text.cpp and strgen_base.cpp. More...

## Macros
#define | StrgenWarning(format_string, ...) StrgenWarningI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))
#define | StrgenError(format_string, ...) StrgenErrorI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))
#define | StrgenFatal(format_string, ...) StrgenFatalI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))

## Functions
const CmdStruct * | TranslateCmdForCompare (const CmdStruct *a)
ParsedCommandStruct | ExtractCommandString (std::string_view s, bool warnings)
void | StrgenWarningI (const std::string &msg)
void | StrgenErrorI (const std::string &msg)
void | StrgenFatalI (const std::string &msg)
std::optional< std::string_view > | ParseWord (StringConsumer &consumer)

## Variables
StrgenState | _strgen

## Detailed Description

Structures related to strgen.

Definition in file strgen.h.

## Macro Definition Documentation

## ◆ StrgenError

#define StrgenError | ( |  | format_string,
|  |  | ...
| ) |  | StrgenErrorI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))

Definition at line 156 of file strgen.h.

## ◆ StrgenFatal

#define StrgenFatal | ( |  | format_string,
|  |  | ...
| ) |  | StrgenFatalI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))

Definition at line 157 of file strgen.h.

## ◆ StrgenWarning

#define StrgenWarning | ( |  | format_string,
|  |  | ...
| ) |  | StrgenWarningI(fmt::format(FMT_STRING(format_string) __VA_OPT__(,) __VA_ARGS__))

Definition at line 155 of file strgen.h.

## Function Documentation

## ◆ ExtractCommandString()

ParsedCommandStruct ExtractCommandString | ( | std::string_view | s,
|  | bool | warnings
| ) |  |

Definition at line 383 of file strgen_base.cpp.

## ◆ ParseWord()

std::optional< std::string_view > ParseWord | ( | StringConsumer & | consumer | ) |

Definition at line 189 of file strgen_base.cpp.

## ◆ StrgenErrorI()

void StrgenErrorI | ( | const std::string & | msg | ) |

Definition at line 32 of file game_text.cpp.

## ◆ StrgenFatalI()

void StrgenFatalI | ( | const std::string & | msg | ) |

Definition at line 38 of file game_text.cpp.

## ◆ StrgenWarningI()

void StrgenWarningI | ( | const std::string & | msg | ) |

Definition at line 26 of file game_text.cpp.

## ◆ TranslateCmdForCompare()

const CmdStruct * TranslateCmdForCompare | ( | const CmdStruct * | a | ) |

Definition at line 412 of file strgen_base.cpp.

## Variable Documentation

## ◆ _strgen

StrgenState _strgen
| extern

Definition at line 24 of file strgen_base.cpp.